/*
 * matmal_04.c
 *
 *  Created on: 2014/01/16
 *      Author: RyzeVia
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define BUFFER_SIZE (128+2) // 128char/line + \n\0
#define FORMAT_SIZE	(BUFFER_SIZE)

void makemat(double a[2][3], double b[3][4], char* filename);
void matmal(double result[2][4], double a[2][3], double b[3][4]);
void printmat(double result[2][4]);

int main(int argc, char **argv) {
	double a[2][3], b[3][4];
	double c[2][4];

	if (argc != 2) {
		printf("Usage: ./a.out <matrix_filename>\n");
		exit(EXIT_FAILURE);
	}

	makemat(a,b, argv[1]);
	matmal(c, a, b);
	printmat(c);

	return EXIT_SUCCESS;
}
void makemat(double a[2][3], double b[3][4], char* filename){
	int i = 0, j = 0;
	int xa=2, xbya=3, yb=4;
	FILE *fp;
	char buf[BUFFER_SIZE];
	char format[FORMAT_SIZE];
	char *s;

	fp = fopen(filename, "r");
	if (fp == NULL) {
		perror("fopen:");
		exit(EXIT_FAILURE);
	}

	// FIXME: このプログラムはバッファを超える長い行を入力されると破たんすることがある
	while (fgets(buf, BUFFER_SIZE, fp) != NULL) {
//		printf("%s\n", buf);
		s = strtok(buf, " ");
		while(s != NULL){
			if(i < 2){
				sscanf(s, "%lf", &(a[i][j]));
//				printf("a[%d][%d]=%lf\n", i, j, a[i][j]);
			}else{
				sscanf(s, "%lf", &(b[i-2][j]));
//				printf("b[%d][%d]=%lf\n", i-2, j, b[i-2][j]);
			}
			s = strtok(NULL, " ");
			j++;
		}
		i++;
		j=0;
	}

	fclose(fp);

}

void matmal(double result[2][4], double a[2][3],double b[3][4]){
	int i, j, k;
	int xa = 2, xbya = 3, yb = 4;

	for(i = 0; i < xa; i++){
		for(j = 0; j < yb; j++){
			result[i][j] = 0;
			for(k = 0; k < xbya; k++){
				result[i][j] += a[i][k] * b[k][j];
			}
		}
	}
}

void printmat(double result[2][4]){
	int i, j;
	int x=2, y=4;
	for(i = 0; i < x; i++){
		for(j = 0; j < y; j++){
			printf("%lf ", result[i][j]);
		}
		printf("\n");
	}
}
